## argparse-1.6.6.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

set(VERSION_MAJOR 1)
set(VERSION_MINOR 6)
set(VERSION_PATCH 6)

if (${CMAKE_VERSION} VERSION_LESS "3.8")
    project("ArgumentParser"
        VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
        LANGUAGES CXX
    )
else()
    project("ArgumentParser"
        DESCRIPTION "C++ argument parser"
        VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
        LANGUAGES CXX
    )
endif()

if (MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4 /EHsc")
else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wold-style-cast -Wextra -Wundef -Wsign-compare -Wconversion -Wpointer-arith -Weffc++ -Wnon-virtual-dtor -Wsign-conversion")
endif()

if (NOT CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 11)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(ARGPARSE_HEADER include/argparse/argparse.hpp)

if (${CMAKE_VERSION} VERSION_LESS "3.19")
    add_library(argparse INTERFACE)
else()
    add_library(argparse INTERFACE ${ARGPARSE_HEADER})
endif()

if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
    include(GNUInstallDirs)

    target_include_directories(
        argparse INTERFACE
            $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
            $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    )

    install(FILES ${ARGPARSE_HEADER} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/argparse)

    set(CPACK_GENERATOR "DEB")
    set(CPACK_PACKAGE_NAME "cpp-argparse-dev")
    set(CPACK_PACKAGE_MAINTAINER "Mikhail Golubchikov")
    set(CMAKE_PROJECT_HOMEPAGE_URL "https://github.com/rue-ryuzaki/argparse")
    if (${CMAKE_VERSION} VERSION_LESS "3.12")
        set(CPACK_PACKAGE_VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
    endif()
    set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
    set(CPACK_RESOURCE_FILE_README "${CMAKE_CURRENT_SOURCE_DIR}/README.md")
    ## DEB
    set(CPACK_DEBIAN_PACKAGE_NAME "${CPACK_PACKAGE_NAME}")
    set(CPACK_DEBIAN_PACKAGE_DESCRIPTION "Python-like header-only C++ argument parser")
    set(CPACK_DEBIAN_PACKAGE_MAINTAINER "${CPACK_PACKAGE_MAINTAINER}")
    set(CPACK_DEBIAN_PACKAGE_SUGGESTS "cmake, build-essential")
    if (NOT ${CMAKE_VERSION} VERSION_LESS "3.6")
        set(CPACK_DEBIAN_FILE_NAME DEB-DEFAULT)
    endif()
    ## RPM
    set(CPACK_RPM_PACKAGE_NAME "${CPACK_PACKAGE_NAME}")
    set(CPACK_RPM_PACKAGE_DESCRIPTION "${CPACK_DEBIAN_PACKAGE_DESCRIPTION}")
    set(CPACK_RPM_PACKAGE_MAINTAINER "${CPACK_PACKAGE_MAINTAINER}")
    set(CPACK_RPM_PACKAGE_SUGGESTS "${CPACK_DEBIAN_PACKAGE_SUGGESTS}")
    set(CPACK_RPM_PACKAGE_LICENSE "MIT")
    if (NOT ${CMAKE_VERSION} VERSION_LESS "3.6")
        set(CPACK_RPM_FILE_NAME RPM-DEFAULT)
    endif()

    set(CPACK_DEB_COMPONENT_INSTALL ON)
    set(CPACK_RPM_COMPONENT_INSTALL ON)
    include(CPack)
endif()

if (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
    include(GNUInstallDirs)

    target_include_directories(
        argparse INTERFACE
            $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
            $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    )

    install(FILES ${ARGPARSE_HEADER} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/argparse)
endif()

enable_testing()
add_subdirectory(test)

=== debian/changelog ===
cpp-argparse-dev (1.6.6-0ppa0) focal; urgency=low

  * Update: C++98 shared_ptr implementation
  * Update: format tab up to ARGPARSE_TAB_SIZE (default 4) spaces
  * Fix: Allow share dest storage #9

 -- Mikhail Golubchikov <golubchikov.mihail@gmail.com>  Sat, 23 Jul 2022 20:29:06 +0300

cpp-argparse-dev (1.6.5-0ppa0) focal; urgency=low

  * Add: missing ArgumentParser functions for C++98
  * Update: Argument::metavar functions

 -- Mikhail Golubchikov <golubchikov.mihail@gmail.com>  Sat, 25 Jun 2022 20:29:39 +0300

cpp-argparse-dev (1.6.4-0ppa0) focal; urgency=low

  * Add: C++98 standard support for Namespace::get
  * Add: C++98 standard support for detail::Type

 -- Mikhail Golubchikov <golubchikov.mihail@gmail.com>  Sat, 18 Jun 2022 21:55:33 +0300

cpp-argparse-dev (1.6.3-0ppa0) focal; urgency=low

  * Add: C++98 standard support
  * Fix: detail::_get_type_name() for GCC 4.6

 -- Mikhail Golubchikov <golubchikov.mihail@gmail.com>  Fri, 17 Jun 2022 22:33:32 +0300

cpp-argparse-dev (1.6.2-0ppa0) focal; urgency=low

  * Fix: MSVC standard check
  * Use: handle as C++11+ feature
  * Fix: detail::_format_name implementation
  * Code refactoring and optimizing

 -- Mikhail Golubchikov <golubchikov.mihail@gmail.com>  Fri, 10 Jun 2022 19:48:44 +0300

cpp-argparse-dev (1.6.1-0ppa0) focal; urgency=low

  * Fix: Argument default value using algorithm
  * Fix: MetavarTypeHelpFormatter using
  * Fix: avoid to add default to help if it exists
  * Update: Help formatting

 -- Mikhail Golubchikov <golubchikov.mihail@gmail.com>  Sat, 28 May 2022 18:50:07 +0300

cpp-argparse-dev (1.6.0-0ppa0) focal; urgency=low

  * Set: std::string as basic type for std::string_view
  * Add: std::ostream& operator << overload for Namespace
  * Fix: copy default values from parents
  * Fix: usage generation for required options
  * Add: check for optional mutex arguments
  * Fix: argparse::SUPPRESS for positional arguments
  * Add: ARGPARSE_NO_AUTODETECT to disable terminal size auto-detection
  * Fix: help auto-formatting
  * Fix: show default value
  * Fix: optional argument flag name generation
  * Add: allow providing a tuple to metavar
  * Fix: customizing file parsing
  * Add: required flag to add_mutually_exclusive_group
  * Add: title and description to add_subparsers
  * Fix: don't show help for subparsers without help
  * Add: support for subparser aliases
  * Add: nargs(arparse::REMAINDER) or remainder() support
  * Add: %(prog)s format specifier for usage and help
  * Add: %(default)s format specifier for argument help
  * Add: set argument type if calling Argument::*_value<T>(T)
  * Remove: deprecated code
  * Add: argument flags, dest, parser name formatting

 -- Mikhail Golubchikov <golubchikov.mihail@gmail.com>  Fri, 20 May 2022 20:57:42 +0300

cpp-argparse-dev (1.5.2-0ppa0) focal; urgency=low

  * Fix: Argument::choices({ A, B }) with 2 choices

 -- Mikhail Golubchikov <golubchikov.mihail@gmail.com>  Fri, 13 May 2022 19:40:57 +0300

cpp-argparse-dev (1.5.1-0ppa0) focal; urgency=low

  * Fix: conflicting option string error
  * Fix: Namespace::try_get for std::array type
  * Remove: required const value for *_const actions
  * Remove: default value check for append_const actions
  * Code refactoring and optimizing

 -- Mikhail Golubchikov <golubchikov.mihail@gmail.com>  Sun, 08 May 2022 18:14:22 +0300

cpp-argparse-dev (1.5.0-0ppa0) focal; urgency=low

  * Rewrite parents support implementation
  * Rewrite parser's prog name generation
  * Use ArgumentParser as Subparser's parser
  * Mark ArgumentParser::Parser deprecated
  * Fix: conflicting option error
  * Fix: mutually exclusive group help
  * Fix: arguments order in Namespace
  * Fix: subparsers required error message
  * Fix: required args check
  * Add: title, description ArgumentGroup setters

 -- Mikhail Golubchikov <golubchikov.mihail@gmail.com>  Sat, 30 Apr 2022 17:41:21 +0300

cpp-argparse-dev (1.4.2-0ppa0) focal; urgency=low

  * Add paired containers support to Namespace::get()
  * Add tupled containers support to Namespace::get()
  * Add 2D containers of queue support to Namespace::get()
  * Update type check
  * Fix parseing if Namespace exists
  * Fix read args from file implementation
  * Fix type name determine on windows
  * Add base support for Parser's parents

 -- Mikhail Golubchikov <golubchikov.mihail@gmail.com>  Sat, 23 Apr 2022 17:21:31 +0300

cpp-argparse-dev (1.4.1-0ppa0) focal; urgency=low

  * Fix code style issues
  * Update terminal size detection on Unix
  * Add Argument::implicit_value() support #4
  * Fix separating argument into abbreviations
  * Mark Namespace::try_get deprecated for C++14
  * Code refactoring and optimizing

 -- Mikhail Golubchikov <golubchikov.mihail@gmail.com>  Sat, 16 Apr 2022 21:54:25 +0300

cpp-argparse-dev (1.4.0-0ppa0) focal; urgency=low

  * Add 2D containers support for Namespace::get()
  * Update help formatting
  * Allow to set output width
  * Add terminal size auto-detection
  * Rename ExclusiveGroup to MutuallyExclusiveGroup
  * Add add_argument(Argument) to ArgumentGroup and MutuallyExclusiveGroup

 -- Mikhail Golubchikov <golubchikov.mihail@gmail.com>  Sun, 10 Apr 2022 15:22:26 +0300

cpp-argparse-dev (1.3.8-0ppa0) focal; urgency=low

  * Allow to add_argument(Argument().dest(...))
  * Allow to add_argument().dest(...)
  * Add Namespace::print() and Namespace::to_string()
  * Fix default value store
  * Don't handle none argument value
  * Fix nargs "?" with const and action "extend"
  * Fix Namespace::to_string(...)
  * Fix positional args store

 -- Mikhail Golubchikov <golubchikov.mihail@gmail.com>  Sat, 26 Mar 2022 19:58:34 +0300

cpp-argparse-dev (1.3.7-0ppa0) focal; urgency=low

  * Add default value SUPPRESS in get_default
  * Remove SUPPRESS arg from Namespace
  * Refactor add_argument() functions
  * Add new Argument constructors
  * Fix ArgumentParser::exit implementation

 -- Mikhail Golubchikov <golubchikov.mihail@gmail.com>  Sat, 19 Mar 2022 22:22:37 +0300



=== debian/control ===
Source: cpp-argparse-dev
Section: devel
Priority: optional
Maintainer: Mikhail Golubchikov <golubchikov.mihail@gmail.com>
Build-Depends: cmake, build-essential

Package: cpp-argparse-dev
Architecture: any
Description: C++ Argument Parser
 Python-like header-only C++ argument parser

=== debian/rules ===
#!/usr/bin/make -f

BUILDDIR = build_dir

# secondly called by launchpad
build:
	mkdir $(BUILDDIR);
	cd $(BUILDDIR); cmake -DCMAKE_INSTALL_PREFIX=../debian/tmp/usr ..
	make -C $(BUILDDIR)

# thirdly called by launchpad
binary: binary-indep binary-arch

binary-indep:
	# nothing to be done

binary-arch:
	cd $(BUILDDIR); cmake -P cmake_install.cmake
	mkdir debian/tmp/DEBIAN
	dpkg-gencontrol -pcpp-argparse-dev
	dpkg --build debian/tmp ..

# firstly called by launchpad
clean:
	rm -f build
	rm -rf $(BUILDDIR)

.PHONY: binary binary-arch binary-indep clean
